liblogging: beepmessage.h File Reference

Main Page | Compound List | File List | Compound Members | File Members | Related Pages

# beepmessage.h File Reference

The BEEP Message Object. More...

`#include "beepchannel.h"`
`#include "beepsession.h"`

Go to the source code of this file.

## Compounds
struct | sbMesgObject
| The BEEP message object. More...
## Defines
#define | __LIB3195_BEEPMESSAGE_H_INCLUDED__ 1
#define | sbMesgCHECKVALIDOBJECT(x) {assert(x != NULL); assert(x->OID == OIDsbMesg);}
## Typedefs
typedef sbMesgObject | sbMesgObj
## Functions
char * | sbMesgGetRawBuf (sbMesgObj *pThis)
| return the raw buffer object
int | sbMesgGetMIMEHdrSize (sbMesgObj *pThis)
| return the size of the MIME Header (in bytes)
int | sbMesgGetPayloadSize (sbMesgObj *pThis)
| return the size of the actual payload (in bytes)
int | sbMesgGetOverallSize (sbMesgObj *pThis)
| return the overall message size (in bytes)
sbMesgObj * | sbMesgConstrFromFrame (struct sbFramObject *psbFram)
| Constructor to create a Mesg based on provided frame.
sbMesgObj * | sbMesgConstruct (char *pszMIMEHdr, char *pszPayload)
| Constructor to create a Mesg based on provided values.
sbMesgObj * | sbMesgRecvMesg (sbChanObj *)
| Receive a message from a given channel.
srRetVal | sbMIMEExtract (char *pszInBuf, int iInBufLen, char **pszMIMEHdr, char **pszPayload)
| Extract MIME header and body from a given message buffer.
srRetVal | sbMesgSendMesgWithCallback (sbMesgObj *pThis, sbChanObj *pChan, char *pszCmd, SBansno uAnsno, void(*OnFramDestroy)(struct sbFramObject *), void *pUsr)
| Send a message over the specified channel object.
srRetVal | sbMesgSendMesg (sbMesgObj *pThis, sbChanObj *pChan, char *pszCmd, SBansno)
| The same as sbMesgSendMesgWithCallback, except that no callback is provided.
void | sbMesgDestroy (sbMesgObj *pThis)
| Destructor.

## Detailed Description

The BEEP Message Object.

The current implemantation does NOT support fragementation. As such, all calls in this object are directly relayed through to the sbFram object.

Author:
  Rainer Gerhards <rgerhards@adiscon.com>

Date:
  2003-08-04

Copyright 2002-2003 Rainer Gerhards and Adiscon GmbH. All Rights Reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Adiscon GmbH or Rainer Gerhards nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

## Function Documentation

sbMesgObj* sbMesgConstrFromFrame | ( | struct sbFramObject * | psbFram | ) |

  | Constructor to create a Mesg based on provided frame. Parameters:
  psbFram | [in] frame to be used for message creation.
  Return values:
  Pointer | to new message object or NULL if an error occured.

sbMesgObj* sbMesgConstruct | ( | char * | pszMIMEHdr,
|  | char * | pszPayload
| ) |

  | Constructor to create a Mesg based on provided values. with no MIME headers. Parameters:
  szMIMEHdr | [in] buffer to MIME headers. Is copied to private buffer space. May be NULL, in which case no MIME headers are present.
  szPayload | [in] buffer to payload data. Is copied to private buffer. May be NULL, in which case an empty payload is created after the MIME header.
  Return values:
  Pointer | to new message object or NULL if an error occured.

void sbMesgDestroy | ( | sbMesgObj * | pThis | ) |

| Destructor. Does not return any value as the primary function to be used is free() which itself does not return any status.

sbMesgObj* sbMesgRecvMesg | ( | sbChanObj * |  | ) |

  | Receive a message from a given channel. As we do not currently support fragmentation, this method simply reads a single fram off the socket and uses that frame to construct the message. Return values:
  Pointer | to newly constructed MesgObj or NULL if an error occured.

srRetVal sbMesgSendMesgWithCallback | ( | sbMesgObj * | pThis,
|  | sbChanObj * | pChan,
|  | char * | pszCmd,
|  | SBansno | uAnsno,
|  | void(* | OnFramDestroy)(struct sbFramObject *),
|  | void * | pUsr
| ) |

  | Send a message over the specified channel object. Parameters:
  pChan | [in] associated channel. Channel housekeeping data is updated.
  pszCmd | [in] HDR-Command to be used, e.g. "MSG", "ANS", ...
  uAnsno | [in] ansno to use if HDR command is "ANS", ignored otherwise. We recommend setting it to 0 if not used.
  OnFramDestroy | If non-NULL, callback to be called when the frame is destroyed.
  pUsr | If onFramDestroy is non-NULL, the user pointer to be provided to the callback. Otherwise ignored.

srRetVal sbMIMEExtract | ( | char * | pszInBuf,
|  | int | iInBufLen,
|  | char ** | pszMIMEHdr,
|  | char ** | pszPayload
| ) |

| Extract MIME header and body from a given message buffer. Todo: handle empty string